/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | www.openfoam.com
     \\/     M anipulation  |
-------------------------------------------------------------------------------
    Copyright (C) 2013 OpenFOAM Foundation
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "dummyGAgglomeration.H"
#include "addToRunTimeSelectionTable.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

namespace Foam
{
    defineTypeNameAndDebug(dummyGAgglomeration, 0);

    addToRunTimeSelectionTable
    (
        GGAMGAgglomeration,
        dummyGAgglomeration,
        gpulduMesh
    );
}


// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::dummyGAgglomeration::dummyGAgglomeration
(
    const gpulduMesh& mesh,
    const dictionary& controlDict
)
:
    GGAMGAgglomeration(mesh, controlDict),
    nLevels_(controlDict.get<label>("nLevels"))
{
    const label nCoarseCells = mesh.lduAddr().size();

    for
    (
        label nCreatedLevels = 0;
        nCreatedLevels < nLevels_;
        nCreatedLevels++
    )
    {
        nCells_[nCreatedLevels] = nCoarseCells;
        restrictAddressingHost_.set
        (
            nCreatedLevels,
            new labelField(identity(nCoarseCells))
        );

        labelgpuList restrictAddressingTmp(restrictAddressingHost_[nCreatedLevels]);
		
        restrictSortAddressing_.set(nCreatedLevels,new labelgpuField(nCoarseCells));
        labelgpuList& restrictSortAddressing = restrictSortAddressing_[nCreatedLevels];

        thrust::copy
        (
            thrust::make_counting_iterator(0),
            thrust::make_counting_iterator(0)+restrictSortAddressing.size(),
            restrictSortAddressing.begin()
        );

        thrust::stable_sort_by_key
        (
            restrictAddressingTmp.begin(),
            restrictAddressingTmp.end(),
            restrictSortAddressing.begin()
        );

        agglomerateLduAddressing(nCreatedLevels);
    }

    // Shrink the storage of the levels to those created
    compactLevels(nLevels_);
}


// ************************************************************************* //
